com.saxonica.jaxp

## Class ValidatingReader

- java.lang.Object
- - com.saxonica.jaxp.ValidatingReader

- All Implemented Interfaces:
    XMLReader

      public class ValidatingReader
      extends Object
      implements XMLReader

  This class is a Saxon implementation of XMLReader that performs schema validation using Saxon's schema processor.

  This class is supplied for the benefit of applications that expect to perform validation by creating a validating SAX parser; it allows such applications to take advantage of the Saxon validator with no change to the application.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ValidatingReader()` Create a ValidatingReader.
    `ValidatingReader(EnterpriseConfiguration config)` Create a ValidatingReader that uses a specified Saxon Configuration.
    `ValidatingReader(EnterpriseConfiguration config, XMLReader parser)` Create a ValidatingReader based on a supplied Saxon Configuration and a supplied (presumably non-validating) XMLReader to perform the underlying XML parsing.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ContentHandler` | `getContentHandler()` Return the current content handler.
    `DTDHandler` | `getDTDHandler()` Return the current DTD handler.
    `EntityResolver` | `getEntityResolver()` Return the current entity resolver.
    `ErrorHandler` | `getErrorHandler()` Return the current error handler.
    `boolean` | `getFeature(String name)` Look up the value of a feature flag.
    `Object` | `getProperty(String name)` Look up the value of a property.
    `void` | `parse(InputSource input)` Parse an XML document.
    `void` | `parse(String systemId)` Parse an XML document from a system identifier (URI).
    `void` | `setContentHandler(ContentHandler handler)` Allow an application to register a content event handler.
    `void` | `setDTDHandler(DTDHandler handler)` Allow an application to register a DTD event handler.
    `void` | `setEntityResolver(EntityResolver resolver)` Allow an application to register an entity resolver.
    `void` | `setErrorHandler(ErrorHandler handler)` Allow an application to register an error event handler.
    `void` | `setFeature(String name, boolean value)` Set the value of a feature flag.
    `void` | `setProperty(String name, Object value)` Set the value of a property.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ValidatingReader

          public ValidatingReader()

      Create a ValidatingReader. When this option is used, the only way to supply the schema to be used for validation is through the xsi:schemaLocation attribute in the source document.

    - #### ValidatingReader

          public ValidatingReader(EnterpriseConfiguration config)

      Create a ValidatingReader that uses a specified Saxon Configuration.
      Parameters:
        `config` - the Saxon Configuration. The Configuration can be pre-initialized with configuration options; it can also contain a pre-loaded cache of schema components to be used for validation

    - #### ValidatingReader

          public ValidatingReader(EnterpriseConfiguration config,
                          XMLReader parser)

      Create a ValidatingReader based on a supplied Saxon Configuration and a supplied (presumably non-validating) XMLReader to perform the underlying XML parsing.
      Parameters:
        `config` - the Saxon Configuration. The Configuration can be pre-initialized with configuration options; it can also contain a pre-loaded cache of schema components to be used for validation
        `parser` - The XML parser to be used

  - ### Method Detail

    - #### getFeature

          public boolean getFeature(String name)
                             throws SAXNotRecognizedException,
                                    SAXNotSupportedException

      Look up the value of a feature flag.
      Specified by:
        `getFeature` in interface `XMLReader`
      Parameters:
        `name` - The names that are recognized are the union of (a) the flags recognized by the underlying SAX XMLReader, and (b) the properties of the Saxon Configuration that have boolean values. A feature name starting with "http://saxon.sf.net" is assumed to be in the second category; these features are listed in `FeatureKeys`.
      Returns:
        the value of the feature if the name is recognized
      Throws:
        `SAXNotRecognizedException` - if the feature name is not recognized
        `SAXNotSupportedException`

    - #### setFeature

          public void setFeature(String name,
                        boolean value)
                          throws SAXNotRecognizedException,
                                 SAXNotSupportedException

      Set the value of a feature flag.
      Specified by:
        `setFeature` in interface `XMLReader`
      Parameters:
        `name` - The names that are recognized are the union of (a) the flags recognized by the underlying SAX XMLReader, and (b) the properties of the Saxon Configuration that have boolean values. A feature name starting with "http://saxon.sf.net" is assumed to be in the second category; these features are listed in `FeatureKeys`.
        `value` - true or false
      Throws:
        `SAXNotRecognizedException` - if the feature name is not recognized, or if it is the name of a Saxon configuration property whose value is not boolean
        `SAXNotSupportedException`

    - #### getProperty

          public Object getProperty(String name)
                             throws SAXNotRecognizedException,
                                    SAXNotSupportedException

      Look up the value of a property.
      Specified by:
        `getProperty` in interface `XMLReader`
      Parameters:
        `name` - The names that are recognized are the union of (a) the properties recognized by the underlying SAX XMLReader, and (b) the properties of the Saxon Configuration. A feature name starting with "http://saxon.sf.net" is assumed to be in the second category; these features are listed in `FeatureKeys`.
      Returns:
        the value of the property if the name is recognized
      Throws:
        `SAXNotRecognizedException` - if the property name is not recognized
        `SAXNotSupportedException`

    - #### setProperty

          public void setProperty(String name,
                         Object value)
                           throws SAXNotRecognizedException,
                                  SAXNotSupportedException

      Set the value of a property.
      Specified by:
        `setProperty` in interface `XMLReader`
      Parameters:
        `name` - The names that are recognized are the union of (a) the properties recognized by the underlying SAX XMLReader, and (b) the properties of the Saxon Configuration. A feature name starting with "http://saxon.sf.net" is assumed to be in the second category; these features are listed in `FeatureKeys`.

        Saxon accepts the Apache-defined properties `http://apache.org/xml/properties/schema/external-noNamespaceSchemaLocation` and `http://apache.org/xml/properties/schema/external-schemaLocation` to define the location of schema documents. These properties may be set repeatedly to load more than one schema document.

        To enable schema validation using XSD 1.1, the property `FeatureKeys.XSD_VERSION` must be set to the value "1.1".

        `value` - the value of the property
      Throws:
        `SAXNotRecognizedException` - if the property name is not recognized, or if the value is inappropriate
        `SAXNotSupportedException`

    - #### setEntityResolver

          public void setEntityResolver(EntityResolver resolver)

      Allow an application to register an entity resolver.

      If the application does not register an entity resolver, the XMLReader will perform its own default resolution.

      Applications may register a new or different resolver in the middle of a parse, and the SAX parser must begin using the new resolver immediately.

      Specified by:
        `setEntityResolver` in interface `XMLReader`
      Parameters:
        `resolver` - The entity resolver.
      See Also:
        `getEntityResolver()`

    - #### getEntityResolver

          public EntityResolver getEntityResolver()

      Return the current entity resolver.
      Specified by:
        `getEntityResolver` in interface `XMLReader`
      Returns:
        The current entity resolver, or null if none has been registered.
      See Also:
        `setEntityResolver(org.xml.sax.EntityResolver)`

    - #### setDTDHandler

          public void setDTDHandler(DTDHandler handler)

      Allow an application to register a DTD event handler.

      If the application does not register a DTD handler, all DTD events reported by the SAX parser will be silently ignored.

      Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

      Specified by:
        `setDTDHandler` in interface `XMLReader`
      Parameters:
        `handler` - The DTD handler.
      See Also:
        `getDTDHandler()`

    - #### getDTDHandler

          public DTDHandler getDTDHandler()

      Return the current DTD handler.
      Specified by:
        `getDTDHandler` in interface `XMLReader`
      Returns:
        The current DTD handler, or null if none has been registered.
      See Also:
        `setDTDHandler(org.xml.sax.DTDHandler)`

    - #### setContentHandler

          public void setContentHandler(ContentHandler handler)

      Allow an application to register a content event handler.

      If the application does not register a content handler, all content events reported by the SAX parser will be silently ignored.

      Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

      Specified by:
        `setContentHandler` in interface `XMLReader`
      Parameters:
        `handler` - The content handler.
      See Also:
        `getContentHandler()`

    - #### getContentHandler

          public ContentHandler getContentHandler()

      Return the current content handler.
      Specified by:
        `getContentHandler` in interface `XMLReader`
      Returns:
        The current content handler, or null if none has been registered.
      See Also:
        `setContentHandler(org.xml.sax.ContentHandler)`

    - #### setErrorHandler

          public void setErrorHandler(ErrorHandler handler)

      Allow an application to register an error event handler.

      If the application does not register an error handler, all error events reported by the SAX parser will be silently ignored; however, normal processing may not continue. It is highly recommended that all SAX applications implement an error handler to avoid unexpected bugs.

      Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

      Specified by:
        `setErrorHandler` in interface `XMLReader`
      Parameters:
        `handler` - The error handler.
      See Also:
        `getErrorHandler()`

    - #### getErrorHandler

          public ErrorHandler getErrorHandler()

      Return the current error handler.
      Specified by:
        `getErrorHandler` in interface `XMLReader`
      Returns:
        The current error handler, or null if none has been registered.
      See Also:
        `setErrorHandler(org.xml.sax.ErrorHandler)`

    - #### parse

          public void parse(InputSource input)
                     throws IOException,
                            SAXException

      Parse an XML document.

      The application can use this method to instruct the XML reader to begin parsing an XML document from any valid input source (a character stream, a byte stream, or a URI).

      Applications may not invoke this method while a parse is in progress (they should create a new XMLReader instead for each nested XML document). Once a parse is complete, an application may reuse the same XMLReader object, possibly with a different input source. Configuration of the XMLReader object (such as handler bindings and values established for feature flags and properties) is unchanged by completion of a parse, unless the definition of that aspect of the configuration explicitly specifies other behavior. (For example, feature flags or properties exposing characteristics of the document being parsed.)

      During the parse, the XMLReader will provide information about the XML document through the registered event handlers.

      This method is synchronous: it will not return until parsing has ended. If a client application wants to terminate parsing early, it should throw an exception.

      Specified by:
        `parse` in interface `XMLReader`
      Parameters:
        `input` - The input source for the top-level of the XML document.
      Throws:
        `SAXException` - Any SAX exception, possibly wrapping another exception.
        `IOException` - An IO exception from the parser, possibly from a byte stream or character stream supplied by the application.
      See Also:
        `InputSource`, `parse(String)`, `setEntityResolver(org.xml.sax.EntityResolver)`, `setDTDHandler(org.xml.sax.DTDHandler)`, `setContentHandler(org.xml.sax.ContentHandler)`, `setErrorHandler(org.xml.sax.ErrorHandler)`

    - #### parse

          public void parse(String systemId)
                     throws IOException,
                            SAXException

      Parse an XML document from a system identifier (URI).

      This method is a shortcut for the common case of reading a document from a system identifier. It is the exact equivalent of the following:

           parse(new InputSource(systemId));

      If the system identifier is a URL, it must be fully resolved by the application before it is passed to the parser.

      Specified by:
        `parse` in interface `XMLReader`
      Parameters:
        `systemId` - The system identifier (URI).
      Throws:
        `SAXException` - Any SAX exception, possibly wrapping another exception.
        `IOException` - An IO exception from the parser, possibly from a byte stream or character stream supplied by the application.
      See Also:
        `parse(org.xml.sax.InputSource)`

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.